/**********************************************************************
 @see  https://gitea.kiki.kim/HA/rutoxpath/
 @since - 2019
 @author - halliday2023
 ***********************************************************************/
var installURL = "https://gitea.kiki.kim/HA/rutoxpath";
var updateURL = "https://gitea.kiki.kim/HA/rutoxpath/packages"
var uninstallURL = "https://gitea.kiki.kim/HA/rutoxpath";

// Global var to get details form manifest.json
const manifest = browser.runtime.getManifest();
// Open new tab on uninstall extension to get survey
browser.runtime.setUninstallURL(uninstallURL, () => { })

// // Open new tab on installation to show demo about Ruto
// const installedListener = (details) => {
//     if (details.reason == 'install') {
//         installNotification();
//         browser.tabs.create({
//             url: installURL
//         })
//     } else if (details.reason == 'update') {
//         updateNotification();
//         browser.notifications.onClicked.addListener(onClickNoti);
//     }
// }
// function onClickNoti() { browser.tabs.create({ url: updateURL }) }
// const updateNotification = () => {
//     browser.notifications.create({
//         title: `Ruto`,
//         message: `Click here to see the changelog of version ${manifest.version}`,
//         type: 'basic',
//         iconUrl: 'logo/128.png'
//     });
// }
// const installNotification = () => {
//     browser.notifications.create('onInstalled', {
//         title: `Ruto`,
//         message: `Please restart your browser to use Ruto`,
//         type: 'basic',
//         iconUrl: 'logo/128.png'
//     });
// }
// browser.runtime.onInstalled.addListener(installedListener);
//- Required

// To toggle SRC and TGT context menu option
var checkedState = false;
function toggle() {
    checkedState = !checkedState;
    if (checkedState) {
        browser.contextMenus.update('ruto@testleaf.comSRC', { "title": "Select Target", }, () => { })
    } else {
        browser.contextMenus.update('ruto@testleaf.comSRC', { "title": "Select Source", }, () => { })
    }
}
// ContextMenus on browser
browser.contextMenus.create({
    "title": "Add to Ruto",
    "contexts": ["all"],
    "onclick": getXPath
});
// src & target
browser.contextMenus.create({
    "id": "ruto@testleaf.comSRC",
    "title": "Select Source",
    "contexts": ["all"],
    "onclick": getXPathMultiple
});

browser.contextMenus.onClicked.addListener((info, tab) => {
    if (info.menuItemId == "ruto@testleaf.comSRC") {
        toggle();
    }
});

function getXPathMultiple(info, tab) {
    let msg = { subject: "AnchorXP" };
    sendMessageToTabs(tab, info, msg)
}
/********************************************************************* 
 * getXPath
 * Method handle the click event of add to Ruto Menu
 * Parameters:
 * info - Information about the item clicked
 * tab  - The details of the tab where the click took place
 **********************************************************************/

function getXPath(info, tab) {
    let msg = { subject: "getXPath" };
    sendMessageToTabs(tab, info, msg)
}



// Badge (shows no.of XPath in Ruto Badge)
browser.storage.onChanged.addListener(function (changes, storageName) {
    if (storageName == 'local' && 'total' in changes) {
        if (changes.total.newValue === '+1') {
            try { setbadgeAndColor(changes, "red"); } catch (error) { }
        } else {
            try { setbadgeAndColor(changes, "blue"); } catch (error) { }
        }
    }
})

function setbadgeAndColor(changes, color) {
    browser.browserAction.setBadgeBackgroundColor({ color: color });
    browser.browserAction.setBadgeText({ text: changes.total.newValue.toString() });
}

// Get values from content script
window.src = null;
window.dst = null;
window.proOrFol = null;
window.anchor = false;
window.type = null;
window.xpath = null;
window.tag = null;
window.hasFrame = null;
window.variableFromBg = null;
window.defaultXPath = null;
var atrributesArray = null;
window.shadowRoot = false;
var webtable = null;
window.cssPath = null;
browser.runtime.onMessage.addListener(receiver);

function receiver(request, response, sendResponse) {
    window.cssPath = request.cssPath;
    webtable = request.webtabledetails;
    window.shadowRoot = request.shadowRoot;
    window.xpath = request.xpathid;
    window.tag = request.tag;
    window.hasFrame = request.hasFrame;
    window.variableFromBg = request.variableFromBg;
    window.type = request.type;
    window.anchor = request.anchor;
    window.src = request.src;
    window.dst = request.dst;
    window.proOrFol = request.proOrFol;
    window.defaultXPath = request.defaultXPath;
    window.atrributesArray = request.atrributesArray;
}

browser.tabs.onUpdated.addListener(function (tabId, changeInfo, tab) {
    browser.tabs.sendMessage(tabId, {
        subject: "OFF",
    }).then(response => { }).catch(onError);
});
function onError(error) {
    // console.error(`Error: ${error}`);
}
function sendMessageToTabs(tab, info, msg) {
    browser.tabs.sendMessage(
        tab.id,
        msg, { frameId: info.frameId }
    ).then(response => { }).catch(onError);
}